#include "common.h"

BOARDKEY pawnhashtable::getRandom64 (void){
    return ( (__int64)rand() ^((__int64)rand()<<15)^((__int64)rand()<<30) 
              ^((__int64)rand()<<45) ^((__int64)rand()<<60) );
}


pawnhashtable::pawnhashtable(){
      //set size for the hashtable. 
      tablesize=1<<16; //size is number of bits
      //create hashtable
      table=new pawnhash[tablesize];
      //initialise keys... 
      for (int k=0; k<2; k++)//squares
      for (int l=0; l<64; l++)//squares
          {
          hashkey[k][l]=getRandom64();
          }
}

void pawnhashtable::addRemovePawn(BOARDKEY &pawnkey, int toMove, int square){
     //update boardkey
     pawnkey^= hashkey[side(toMove)][square]; 
}


void pawnhashtable::resetHash(void){
      //create new hashtable
      delete table;
      table=new pawnhash[tablesize];
}



//recording and retrieving values from hash
void pawnhashtable::recordHash(BITBOARD &pawnkey, BITBOARD &ppawns, BITBOARD &hppawns, BITBOARD &weakPawns, int val){
    pawnhash* pHash=(table + (pawnkey % tablesize));
    pHash->key=pawnkey;
    pHash->ppawns=ppawns;
    pHash->hppawns=hppawns;
    pHash->weakPawns=weakPawns;
    pHash->value=val;
}// END recordHash.



int pawnhashtable::probeHash(BITBOARD &pawnkey, BITBOARD &ppawns, BITBOARD &hppawns, BITBOARD &weakPawns){
    pawnhash* pHash=(table + (pawnkey % tablesize));
    if (pHash->key==pawnkey){
       //known pawnsituation
       ppawns=pHash->ppawns;
       hppawns=pHash->hppawns;
	   weakPawns=pHash->weakPawns;
       return pHash->value;
    }
    return NODATA;
}
